import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.media.j3d.*;

/**
 * Title: TheHive
 * Description: TheHive is the GUI for swarmarchitecture groups programm
 * to build a architecture with social insects.
 * @author Dimitri Missoh & Daniel Schlosser
 * @version 0.1
 */

public class TheHive extends javax.swing.JFrame
{
    double xRotation,yRotation,zRotation;
    int xTranslation,yTranslation, zTranslation;
    double zoom,fitness;
    int standartRundenzahl;
    int aktuelleRundenzahl;
    boolean automaticFitness=false;
    boolean interactivMode=false;
    boolean building=false;
    int roundsToRunWihthoutUser=0;
    Simulator theSim;
    JReviewDialog reviewD;
    MarkViewDialog markViewD;
    JAboutD aboutD;
    ModellViewer viewport;
    Hilfe helpD;
    FileChooser fileChooserD;
    Canvas3D cv;
    boolean angleOfTransSet=true;
    Einstellungen einstellungen;
    JEAllgemeinD eAllgemeinD;
    JEGenAlgD eGenAlgD;
    JESimulatorD eSimulatorD;
    Timer myTimer=new Timer();
    /**
     * Construct a GUI using  a ModellViewer
     */
	private TheHive()
	{
        xRotation=0.0;
        yRotation=0.0;
        zRotation=0.0;
        xTranslation=0;
        yTranslation=0;
        zTranslation=0;
        zoom=1.0;
        fitness=0.0;
        aktuelleRundenzahl=0;
           GraphicsConfigTemplate3D template = new GraphicsConfigTemplate3D();
           GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
           GraphicsDevice device = env.getDefaultScreenDevice();
           GraphicsConfiguration config = device.getBestConfiguration(template);
           cv = new Canvas3D(config);
           viewport=new ModellViewer(cv,this);
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setJMenuBar(JMenuBar2);
		setTitle("The Hive");
		setDefaultCloseOperation(javax.swing.JFrame.DO_NOTHING_ON_CLOSE);
		getContentPane().setLayout(new BorderLayout(0,0));
                setSize(800,600);
		setVisible(false);
                saveFileDialog.setMode(FileDialog.SAVE);
		saveFileDialog.setTitle("Save");
		openFileDialog.setMode(FileDialog.LOAD);
		openFileDialog.setTitle("Open");
		JPanel2.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		getContentPane().add(BorderLayout.NORTH, JPanel2);
		JPanel1.setLayout(new BorderLayout(0,0));
		getContentPane().add(BorderLayout.CENTER, JPanel1);
                JPanel1.add(cv);
		JPanel3.setLayout(new GridLayout(28,1,0,0));
		JPanel1.add(BorderLayout.EAST,JPanel3);
		JLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel1.setText("Rotation um Achse");
		JPanel3.add(JLabel1);
		JPanel5.setLayout(new BorderLayout(0,0));
		JPanel3.add(JPanel5);
		JLabel2.setText("X");
		JPanel5.add(BorderLayout.EAST,JLabel2);
		XRotationTF.setText("0");
		XRotationTF.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JPanel5.add(BorderLayout.CENTER,XRotationTF);
		XRotationSlider.setMinorTickSpacing(1);
		XRotationSlider.setValue(0);
		XRotationSlider.setMaximum(359);
		XRotationSlider.setSnapToTicks(true);
		XRotationSlider.setMajorTickSpacing(1);
		JPanel3.add(XRotationSlider);
		JPanel6.setLayout(new BorderLayout(0,0));
		JPanel3.add(JPanel6);
		JLabel6.setText("Y");
		JPanel6.add(BorderLayout.EAST,JLabel6);
		YRotationTF.setText("0");
		YRotationTF.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JPanel6.add(BorderLayout.CENTER,YRotationTF);
		YRotationSlider.setMinorTickSpacing(1);
		YRotationSlider.setValue(0);
		YRotationSlider.setMaximum(359);
		YRotationSlider.setSnapToTicks(true);
		YRotationSlider.setMajorTickSpacing(1);
		JPanel3.add(YRotationSlider);
		JPanel7.setLayout(new BorderLayout(0,0));
		JPanel3.add(JPanel7);
		JLabel3.setText("Z");
		JPanel7.add(BorderLayout.EAST,JLabel3);
		ZRotationTF.setText("0");
		ZRotationTF.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JPanel7.add(BorderLayout.CENTER,ZRotationTF);
		ZRotationSlider.setMinorTickSpacing(1);
		ZRotationSlider.setValue(0);
		ZRotationSlider.setMaximum(359);
		ZRotationSlider.setSnapToTicks(true);
		ZRotationSlider.setMajorTickSpacing(1);
		JPanel3.add(ZRotationSlider);
		JLabel4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		JLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel4.setText("Zoom");
		JPanel3.add(JLabel4);
		JLabel4.setBackground(new java.awt.Color(204,204,204));
		JPanel4.setLayout(new BorderLayout(0,0));
		JPanel3.add(JPanel4);
		ZoomTF.setText("100");
		ZoomTF.setColumns(5);
		ZoomTF.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
		JPanel4.add(BorderLayout.CENTER,ZoomTF);
		JLabel5.setText("%");
		JPanel4.add(BorderLayout.EAST,JLabel5);
		JLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel7.setText("Verschiebe Mittelpunkt");
		JPanel3.add(JLabel7);
		JPanel8.setLayout(new BorderLayout(0,0));
		JPanel3.add(JPanel8);
		JLabel8.setText("X");
		JPanel8.add(BorderLayout.WEST,JLabel8);
		XTranslationTF.setText("0");
		XTranslationTF.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JPanel8.add(BorderLayout.CENTER,XTranslationTF);
		XTranslationSlider.setMinimum(-100);
		XTranslationSlider.setMinorTickSpacing(1);
		XTranslationSlider.setValue(0);
		XTranslationSlider.setSnapToTicks(true);
		XTranslationSlider.setMajorTickSpacing(1);
		JPanel3.add(XTranslationSlider);
		JPanel9.setLayout(new BorderLayout(0,0));
		JPanel3.add(JPanel9);
		JLabel9.setText("Y");
		JPanel9.add(BorderLayout.WEST,JLabel9);
		YTranslationTF.setText("0");
		YTranslationTF.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JPanel9.add(BorderLayout.CENTER,YTranslationTF);
		YTranslationSlider.setMinimum(-100);
		YTranslationSlider.setMinorTickSpacing(1);
		YTranslationSlider.setValue(0);
		YTranslationSlider.setSnapToTicks(true);
		YTranslationSlider.setMajorTickSpacing(1);
		JPanel3.add(YTranslationSlider);
		JPanel3.add(JPanel11);
                JPanel11.setLayout(new BorderLayout());
		JLabel14.setText("Z");
		JPanel11.add(JLabel14,BorderLayout.WEST);
		ZTranslationTF.setText("0");
		ZTranslationTF.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JPanel11.add(ZTranslationTF,BorderLayout.CENTER);
		ZTranslationSlider.setMinimum(-100);
		ZTranslationSlider.setMinorTickSpacing(1);
		ZTranslationSlider.setValue(0);
		ZTranslationSlider.setSnapToTicks(true);
		ZTranslationSlider.setMajorTickSpacing(1);
		JPanel3.add(ZTranslationSlider);
		MarkViewB.setText("markieren und ausblenden");
		MarkViewB.setActionCommand("markieren und ausblenden");
		JPanel3.add(MarkViewB);
		JPanel3.add(JLabel10);
		StartSubTreadB.setText("Start");
		StartSubTreadB.setActionCommand("Start");
		StartSubTreadB.setDoubleBuffered(true);
		StartSubTreadB.setEnabled(false);
		JPanel3.add(StartSubTreadB);
		interactivTF.setEditable(false);
		interactivTF.setEnabled(false);
		JPanel3.add(interactivTF);
		StopSubTreadB.setText("Stop");
		StopSubTreadB.setActionCommand("Stop");
		StopSubTreadB.setEnabled(false);
		JPanel3.add(StopSubTreadB);
		InteraktionB.setText("Interaktion");
		InteraktionB.setActionCommand("Interaktion");
		InteraktionB.setEnabled(false);
		JPanel3.add(InteraktionB);
		JPanel3.add(JLabel11);
		JPanel JPinf=new JPanel();
		JPinf.setLayout(new GridLayout(1,2));
		JLabel JL=new JLabel("Nest:");
		JPinf.add(JL);
		HiveTF.setEditable(false);
		JPinf.add(HiveTF);
		JPanel3.add(JPinf);
		JPanel3.add(this.HiveInfoB);
		JLabel12.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		JLabel12.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JLabel12.setText("Fitness");
		JPanel3.add(JLabel12);
		JPanel10.setLayout(new BorderLayout(0,0));
		JPanel3.add(JPanel10);
		JLabel13.setText("%");
		JPanel10.add(BorderLayout.EAST,JLabel13);
		FitnessTF.setText("0");
		FitnessTF.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		JPanel10.add(BorderLayout.CENTER,FitnessTF);
		NextB.setText("OK");
		NextB.setActionCommand("OK");
		JPanel3.add(NextB);
		JPopupMenu.setDefaultLightWeightPopupEnabled(false);
                ToolTipManager.sharedInstance().setLightWeightPopupEnabled(false);
                JMenuBar2.add(JMenu1);
		JMenuItemNeu.setText("Neu bauen");
		JMenuItemNeu.setActionCommand("Neu");
		JMenu1.add(JMenuItemNeu);
		JMenuItemTotalReset.setText("Alles Neu");
		JMenuItemTotalReset.setActionCommand("Alles Neu");
		JMenu1.add(JMenuItemTotalReset);
		JMenuItemLoad.setText("Laden...");
		JMenuItemLoad.setActionCommand("Laden...");
		JMenu1.add(JMenuItemLoad);
		JMenuItemStore.setText("Speichern");
		JMenuItemStore.setActionCommand("Speichern");
		JMenu1.add(JMenuItemStore);
		JMenuItemExit.setText("Beenden");
		JMenuItemExit.setActionCommand("Beenden");
		JMenu1.add(JMenuItemExit);
		JMenuBar2.add(JMenu2);
		JMenuItemAllgemein.setText("Allgemeine...");
		JMenuItemAllgemein.setActionCommand("Allgemeine...");
		JMenu2.add(JMenuItemAllgemein);
		JMenuItemSimulator.setText("Simulator...");
		JMenuItemSimulator.setActionCommand("Simulator...");
		JMenu2.add(JMenuItemSimulator);
		JMenuItemGenA.setText("Genetischer Algorithmus...");
		JMenuItemGenA.setActionCommand("Genetischer Algorithmus...");
		JMenu2.add(JMenuItemGenA);
		JMenuBar2.add(JMenu4);
		JMenuItemReview.setText("Start Review");
		JMenuItemReview.setActionCommand("Start Review");
		JMenu4.add(JMenuItemReview);
		JMenuBar2.add(JMenu5);
		JMenuItemHelp.setText("Hife...");
		JMenuItemHelp.setActionCommand("Hife...");
		JMenu5.add(JMenuItemHelp);
		JMenuItemAbout.setText("ber...");
		JMenuItemAbout.setActionCommand("ber...");
		JMenu5.add(JMenuItemAbout);
		//}}
		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		HiveInfoB.addActionListener(lSymAction);
		JMenuItemLoad.addActionListener(lSymAction);
		JMenuItemStoreAs.addActionListener(lSymAction);
		JMenuItemExit.addActionListener(lSymAction);
		JMenuItemAllgemein.addActionListener(lSymAction);
		JMenuItemSimulator.addActionListener(lSymAction);
		JMenuItemGenA.addActionListener(lSymAction);
		JMenuItemReview.addActionListener(lSymAction);
		JMenuItemHelp.addActionListener(lSymAction);
		XRotationTF.addActionListener(lSymAction);
		SymChange lSymChange = new SymChange();
		XRotationSlider.addChangeListener(lSymChange);
		YRotationTF.addActionListener(lSymAction);
		YRotationSlider.addChangeListener(lSymChange);
		ZRotationTF.addActionListener(lSymAction);
		ZRotationSlider.addChangeListener(lSymChange);
		ZoomTF.addActionListener(lSymAction);
		XTranslationTF.addActionListener(lSymAction);
		XTranslationSlider.addChangeListener(lSymChange);
		YTranslationTF.addActionListener(lSymAction);
		YTranslationSlider.addChangeListener(lSymChange);
		ZTranslationTF.addActionListener(lSymAction);
		ZTranslationSlider.addChangeListener(lSymChange);
		FitnessTF.addActionListener(lSymAction);
		NextB.addActionListener(lSymAction);
		JMenuItemAbout.addActionListener(lSymAction);
		JMenuItemNeu.addActionListener(lSymAction);
		JMenuItemTotalReset.addActionListener(lSymAction);
		MarkViewB.addActionListener(lSymAction);
		JMenuItemStore.addActionListener(lSymAction);
		InteraktionB.addActionListener(lSymAction);
		StartSubTreadB.addActionListener(lSymAction);
		StopSubTreadB.addActionListener(lSymAction);
		//}}
            //und nun die Dialoge erstellen
            fileChooserD=new FileChooser(this);
   	    reviewD=new JReviewDialog(this);
            markViewD=new MarkViewDialog(this,viewport);
	    viewport.initDialogConection(markViewD);
            aboutD=new JAboutD(this);
            helpD=new Hilfe(this);
            theSim=new Environment();
	    einstellungen=new Einstellungen(theSim,this,this.viewport);
	    eAllgemeinD=new JEAllgemeinD(einstellungen);
	    eGenAlgD=new JEGenAlgD(einstellungen);
	    eSimulatorD=new JESimulatorD(einstellungen);
	    theSim.resetTotal();
	    this.setupNewView();
	}
	/**
	 * The entry point for this application.
	 * Sets the Look and Feel to the System Look and Feel.
	 * Creates a new The Hive and makes it visible.
	 */
	static public void main(String args[])
	{                
                System.setErr( System.out );

        	try {
		    try {
		        UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		    }
		    catch (Exception e) {
		    }
			(new TheHive()).setVisible(true);
		}
		catch (Throwable t) {
			t.printStackTrace();
			System.exit(1);
		}
	}

	//{{DECLARE_CONTROLS
	java.awt.FileDialog saveFileDialog = new java.awt.FileDialog(this);
	java.awt.FileDialog openFileDialog = new java.awt.FileDialog(this);
	javax.swing.JButton HiveInfoB = new JButton("Info");
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel5 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField XRotationTF = new javax.swing.JTextField();
	javax.swing.JSlider XRotationSlider = new javax.swing.JSlider();
	javax.swing.JPanel JPanel6 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField YRotationTF = new javax.swing.JTextField();
	javax.swing.JSlider YRotationSlider = new javax.swing.JSlider();
	javax.swing.JPanel JPanel7 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField ZRotationTF = new javax.swing.JTextField();
	javax.swing.JSlider ZRotationSlider = new javax.swing.JSlider();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel4 = new javax.swing.JPanel();
	javax.swing.JTextField ZoomTF = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel8 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JTextField XTranslationTF = new javax.swing.JTextField();
	javax.swing.JSlider XTranslationSlider = new javax.swing.JSlider();
	javax.swing.JPanel JPanel9 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JTextField YTranslationTF = new javax.swing.JTextField();
	javax.swing.JSlider YTranslationSlider = new javax.swing.JSlider();
	javax.swing.JButton MarkViewB = new javax.swing.JButton();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JButton StartSubTreadB = new javax.swing.JButton();
	javax.swing.JTextField interactivTF = new javax.swing.JTextField();
	javax.swing.JButton StopSubTreadB = new javax.swing.JButton();
	javax.swing.JButton InteraktionB = new javax.swing.JButton();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JPanel JPanel10 = new javax.swing.JPanel();
	javax.swing.JLabel JLabel13 = new javax.swing.JLabel();
	javax.swing.JTextField FitnessTF = new javax.swing.JTextField();
	javax.swing.JButton NextB = new javax.swing.JButton();
	javax.swing.JMenuBar JMenuBar2 = new javax.swing.JMenuBar();
	javax.swing.JMenu JMenu1 = new javax.swing.JMenu("Nest");
	javax.swing.JMenuItem JMenuItemNeu = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItemTotalReset = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItemLoad = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItemStore = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItemStoreAs = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItemExit = new javax.swing.JMenuItem();
	javax.swing.JMenu JMenu2 = new javax.swing.JMenu("Einstellungen");
	javax.swing.JMenuItem JMenuItemAllgemein = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItemSimulator = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItemGenA = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItemSaveOptions = new javax.swing.JMenuItem();
	javax.swing.JMenu JMenu4 = new javax.swing.JMenu("Review");
	javax.swing.JMenuItem JMenuItemReview = new javax.swing.JMenuItem();
	javax.swing.JMenu JMenu5 = new javax.swing.JMenu("?");
	javax.swing.JMenuItem JMenuItemHelp = new javax.swing.JMenuItem();
	javax.swing.JMenuItem JMenuItemAbout = new javax.swing.JMenuItem();
        javax.swing.JPanel JPanel11 = new javax.swing.JPanel();
        javax.swing.JLabel JLabel14 = new javax.swing.JLabel();
	javax.swing.JTextField ZTranslationTF = new javax.swing.JTextField();
	javax.swing.JSlider ZTranslationSlider = new javax.swing.JSlider();
	javax.swing.JTextField HiveTF = new JTextField();
	JInfoDialog infoD=new JInfoDialog();
	//}}

  /**
   * Routine sets up a new view, by clearing the 3D view and reseting all dialoges
   */
      private void setupNewView()
      {
            viewport.clearall();
            markViewD.reset();
            reviewD.setActualRound(standartRundenzahl);
            viewport.addCell(theSim.laufeRunden(this.standartRundenzahl) );
            aktuelleRundenzahl=standartRundenzahl;
	    viewport.setPositionOfFirstHoneycomb(theSim.getCrystallizationPoint());
            viewport.addBee(theSim.getAgentPos(this.standartRundenzahl));
            viewport.translateToCoordinates(theSim.getCrystallizationPoint());
            viewport.rotateAbsolutX(0.0);
            viewport.rotateAbsolutY(0.0);
            viewport.rotateAbsolutZ(0.0);
            viewport.zoomAbsolut(1.0);
            Koord3D p=theSim.getCrystallizationPoint();
            setRotationValueViewOnline();
            this.setTranslationState(p.getX(),p.getY(),p.getZ());
            this.setZoomState(1.0);
            XRotationSlider.setValue(45);
            XRotationTF.setText("45");
            YRotationSlider.setValue(45);
            YRotationTF.setText("45");
            ZRotationSlider.setValue(0);
            ZRotationTF.setText("0");
            HiveTF.setText(""+String.valueOf(theSim.getIndexOfCurrentNest()+1)+" / "+theSim.getNumberOfNests());
	    interactivTF.setText(String.valueOf(standartRundenzahl));
	    Koord3D k=viewport.getSize();
            if(einstellungen!=null)
            {
            double inti=einstellungen.getSizeOfUmgebungen();
	    double fitness=(k.getX()/inti+k.getY()/inti+k.getZ()/inti)/3.0;
	    fitness*=0.5;
	    fitness+=0.5*viewport.getDichte(theSim.getNumberBuiltBlocks());
	    fitness*=100;
	    this.FitnessTF.setText(String.valueOf(fitness));
            }
            Graphics g=this.FitnessTF.getGraphics();
	    this.FitnessTF.update(g);
	    if(this.automaticFitness&&this.roundsToRunWihthoutUser!=0)
	    {
		System.out.println("erzeuge neue Umgebung!");
		try{
		    this.wait(1000);
		}catch(Exception e){}
		NextB_actionPerformed(new ActionEvent(this,0,""));
	    }
      }
      /**
       * makes the view step n rounds back
       * @param n the number of rounds to step back
       */
      void stepNRoundsBack(int n)
      {
            if(aktuelleRundenzahl-n<1)
            {
                viewport.clearall();
                viewport.addBee(theSim.getAgentPos(0));
                reviewD.setActualRound(0);
                this.aktuelleRundenzahl=0;
            }else
            {
                for(int i=this.aktuelleRundenzahl;i>aktuelleRundenzahl-n;i--)
                    viewport.removeCell(theSim.gebautInRunde(i));
                reviewD.setActualRound(this.aktuelleRundenzahl-n);
                this.aktuelleRundenzahl-=n;
                viewport.moveBees(theSim.getAgentPos(this.aktuelleRundenzahl));
            }
        }
      /**
       * makes the view step n rounds forward
       * @param n the number of rounds to step forward
       */
        void stepNRoundsForward(int n)
        {
            if(aktuelleRundenzahl+n>standartRundenzahl){
                for(int i=this.aktuelleRundenzahl+1;i<=this.standartRundenzahl;i++)
                    viewport.addCell(theSim.gebautInRunde(i));
                reviewD.setActualRound(this.standartRundenzahl);
                this.aktuelleRundenzahl=this.standartRundenzahl;
                viewport.moveBees(theSim.getAgentPos(this.aktuelleRundenzahl));
            }else
            {
                for(int i=this.aktuelleRundenzahl+1;i<=this.aktuelleRundenzahl+n;i++)
                    viewport.addCell(theSim.gebautInRunde(i));
                reviewD.setActualRound(this.aktuelleRundenzahl+n);
                this.aktuelleRundenzahl+=n;
                viewport.moveBees(theSim.getAgentPos(this.aktuelleRundenzahl));
            }
        }
      /**
       * The view will step back to the first round of the simulation
       */
        void stepToGenesis(){
            viewport.clearall();
            viewport.addBee(theSim.getAgentPos(0));
            reviewD.setActualRound(0);
            this.aktuelleRundenzahl=0;
        }
      /**
       * The view will step foward to the last round of the simulation
       */
        void stepToEnd(){
            for(int i=this.aktuelleRundenzahl;i<=this.standartRundenzahl;i++)
                 viewport.addCell(theSim.gebautInRunde(i));
            this.aktuelleRundenzahl=this.standartRundenzahl;
            reviewD.setActualRound(this.aktuelleRundenzahl);
            viewport.moveBees(theSim.getAgentPos(this.aktuelleRundenzahl));
        }
/*
 * Von hier ab werden Button und Windowlistener sowie die Menues implementiert
 */
	void JMenuItemNeu_actionPerformed(java.awt.event.ActionEvent event)
	{
                theSim.resetNest();
                setupNewView();
	}

	void JMenuItemTotalReset_actionPerformed(java.awt.event.ActionEvent event)
	{
		theSim.resetTotal();
                setupNewView();
	}
        void JMenuItemLoad_actionPerformed(java.awt.event.ActionEvent event)
	{
		fileChooserD.loadFileChooser(theSim);
		NextB_actionPerformed(new ActionEvent(this,0,""));
	}

	void JMenuItemStore_actionPerformed(java.awt.event.ActionEvent event)
	{
		JMenuItemStoreAs_actionPerformed(event);
	}

	void JMenuItemStoreAs_actionPerformed(java.awt.event.ActionEvent event)
	{
		fileChooserD.saveFileChooser(theSim);
	}

	void JMenuItemExit_actionPerformed(java.awt.event.ActionEvent event)
	{
	    exitApplication();
	}


        void exitApplication()
	{
		try {
	    	// Beep
	    	Toolkit.getDefaultToolkit().beep();
	    	// Show a confirmation dialog
	    	int reply = JOptionPane.showConfirmDialog(this,
	    	                                          "Do you really want to exit?",
	    	                                          "The Hive - Exit" ,
	    	                                          JOptionPane.YES_NO_OPTION,
	    	                                          JOptionPane.QUESTION_MESSAGE);
			// If the confirmation was affirmative, handle exiting.
			if (reply == JOptionPane.YES_OPTION)
			{
			this.einstellungen.setAutomaticFitness(false);
		    	this.setVisible(false);    // hide the Frame
		    	this.dispose();            // free the system resources
		    	System.exit(0);            // close the application
			}
		} catch (Exception e) {
		}
	}
	void JMenuItemGenA_actionPerformed(java.awt.event.ActionEvent event)
	{
	    this.eGenAlgD.setVisible(true);
	}
	void JMenuItemAllgemein_actionPerformed(java.awt.event.ActionEvent event)
	{                      
	    this.eAllgemeinD.setVisible(true);
	}
	void JMenuItemSimulator_actionPerformed(java.awt.event.ActionEvent event)
	{
	    this.eSimulatorD.setVisible(true);
	}
        void JMenuItemSaveOptions_actionPerformed(java.awt.event.ActionEvent event)
        {
              //Einstellungen ref;
              //ref = new Einstellungen();
              //ref.speichern();
              //zeigt auf der Konsole die gespeicherten Werte an(nur als Test).
              //ref.lesen();
        }

	void JMenuItemAbout_actionPerformed(java.awt.event.ActionEvent event)
	{
		aboutD.setVisible(true);
	}

        void JMenuItemHelp_actionPerformed(java.awt.event.ActionEvent event)
        {
            helpD.setVisible(true);
        }

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == TheHive.this)
				TheHive_windowClosing(event);
		}
	}

	void TheHive_windowClosing(java.awt.event.WindowEvent event)
	{
		TheHive_windowClosing_Interaction1(event);
	}

	void TheHive_windowClosing_Interaction1(java.awt.event.WindowEvent event) {
		try {
			this.exitApplication();
		} catch (Exception e) {
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			building=false;
			Object object = event.getSource();
			if (object == JMenuItemNeu)
				JMenuItemNeu_actionPerformed(event);
			else if (object == JMenuItemTotalReset)
				JMenuItemTotalReset_actionPerformed(event);
			else if (object == JMenuItemLoad)
				JMenuItemLoad_actionPerformed(event);
			else if (object == JMenuItemStore)
				JMenuItemStore_actionPerformed(event);
			else if (object == JMenuItemStoreAs)
				JMenuItemStoreAs_actionPerformed(event);
			else if (object == JMenuItemExit)
				JMenuItemExit_actionPerformed(event);
			else if (object == JMenuItemSimulator)
			        JMenuItemSimulator_actionPerformed(event);
                        else if (object == JMenuItemAllgemein)
			        JMenuItemAllgemein_actionPerformed(event);
			else if (object == JMenuItemGenA)
			        JMenuItemGenA_actionPerformed(event);
                        else if (object == JMenuItemSaveOptions)
                                JMenuItemSaveOptions_actionPerformed(event);
			else if (object == JMenuItemReview)
				JMenuItemReview_actionPerformed(event);
			else if (object == JMenuItemHelp)
				JMenuItemHelp_actionPerformed(event);
			else if (object == JMenuItemAbout)
				JMenuItemAbout_actionPerformed(event);
			else if (object == XRotationTF)
				XRotationTF_actionPerformed(event);
			else if (object == YRotationTF)
				YRotationTF_actionPerformed(event);
			else if (object == ZRotationTF)
				ZRotationTF_actionPerformed(event);
			else if (object == ZoomTF)
				ZoomTF_actionPerformed(event);
			else if (object == XTranslationTF)
				XTranslationTF_actionPerformed(event);
			else if (object == YTranslationTF)
				YTranslationTF_actionPerformed(event);
                        else if (object == ZTranslationTF)
                                ZTranslationTF_actionPerformed(event);
			else if (object == MarkViewB)
				MarkViewB_actionPerformed(event);
			else if (object == FitnessTF)
				FitnessTF_actionPerformed(event);
			else if (object == NextB)
				NextB_actionPerformed(event);
			else if (object == interactivTF)
			       ;// interactivTF_actionPerformed(event);
			else if (object == StartSubTreadB)
			        building=true;
			else if (object == StopSubTreadB)
			     {
			        building=false;
				Koord3D k=viewport.getSize();
				double inti=einstellungen.getSizeOfUmgebungen();
			        double fitness=(k.getX()/inti+k.getY()/inti+k.getZ()/inti)/3.0;
				fitness*=0.5;
	                        fitness+=0.5*viewport.getDichte(theSim.getNumberBuiltBlocks());
	                        fitness*=100;
	                        FitnessTF.setText(String.valueOf(fitness));
			     }
			else if (object == HiveInfoB)
			        HiveInfoB_actionPerformed(event);
		}
	}
	class SymChange implements javax.swing.event.ChangeListener
	{
		public void stateChanged(javax.swing.event.ChangeEvent event)
		{
			Object object = event.getSource();
			if (object == XRotationSlider)
				XRotationSlider_stateChanged(event);
			else if (object == YRotationSlider)
				YRotationSlider_stateChanged(event);
			else if (object == ZRotationSlider)
				ZRotationSlider_stateChanged(event);
			else if (object == XTranslationSlider)
				XTranslationSlider_stateChanged(event);
			else if (object == YTranslationSlider)
				YTranslationSlider_stateChanged(event);
                        else if (object == ZTranslationSlider)
                                ZTranslationSlider_stateChanged(event);
		}
	}

	void HiveInfoB_actionPerformed(java.awt.event.ActionEvent event)
	{
	    Koord3D size=viewport.getSize();
            infoD.setupText("Nest: "+(theSim.getIndexOfCurrentNest()+1) +" von "+theSim.getNumberOfNests()
		       +"\nVon "+theSim.getNumberAgents()+ " Agenten"
	               +"\nwurden "+theSim.getNumberBuiltBlocks()+" Waben gebaut."
		       +"\nDas Nest hat eine Gre von "+ (size.getX()+1)+"x"+(size.getY()+1)+"x"+(size.getZ()+1)
		       +"\nund erreichte eine Dichte von "+viewport.getDichte(theSim.getNumberBuiltBlocks())
		           );
	    infoD.setVisible(true);
	}
	void JMenuItemReview_actionPerformed(java.awt.event.ActionEvent event)
	{
		reviewD.setVisible(true);
	}

	void XRotationTF_actionPerformed(java.awt.event.ActionEvent event)
	{
                if(!this.angleOfTransSet )
                {
                    this.setRotationValueViewOnline();
                    return;
                }
		int puffer;
		try{
		    puffer=Integer.parseInt(XRotationTF.getText());
		}catch(Exception e){
		    puffer=0;
		}
		puffer=puffer%360;
		XRotationTF.setText(String.valueOf(puffer));
		xRotation=puffer;
		XRotationSlider.setValue(puffer);
		viewport.rotateAbsolutX(puffer/180.0*Math.PI);
	}

	void XRotationSlider_stateChanged(javax.swing.event.ChangeEvent event)
	{
                if(!this.angleOfTransSet) setRotationValueViewOnline();
		int puffer=XRotationSlider.getValue();
		xRotation=puffer;
		XRotationTF.setText(String.valueOf(puffer));
		viewport.rotateAbsolutX(puffer/180.0*Math.PI);
	}

	void YRotationTF_actionPerformed(java.awt.event.ActionEvent event)
	{
                if(!this.angleOfTransSet )
                {
                    this.setRotationValueViewOnline();
                    return;
                }
		int puffer;
		try{
		    puffer=Integer.parseInt(YRotationTF.getText());
		}catch(Exception e){
		    puffer=0;
		}
		puffer=puffer%360;
		YRotationTF.setText(String.valueOf(puffer));
		yRotation=puffer;
		YRotationSlider.setValue(puffer);
		viewport.rotateAbsolutY(puffer/180.0*Math.PI);
	}

	void YRotationSlider_stateChanged(javax.swing.event.ChangeEvent event)
	{
                if(!this.angleOfTransSet )
                {
                    this.setRotationValueViewOnline();
                    return;
                }
                int puffer=YRotationSlider.getValue();
		yRotation=puffer;
		YRotationTF.setText(String.valueOf(puffer));
		viewport.rotateAbsolutY(puffer/180.0*Math.PI);
	}

	void ZRotationTF_actionPerformed(java.awt.event.ActionEvent event)
	{
                if(!this.angleOfTransSet )
                {
                    this.setRotationValueViewOnline();
                    return;
                }
	    int puffer;
	    try{
		    puffer=Integer.parseInt(ZRotationTF.getText());
		}catch(Exception e){
		    puffer=0;
		}
		puffer=puffer%360;
		ZRotationTF.setText(String.valueOf(puffer));
		zRotation=puffer;
		ZRotationSlider.setValue(puffer);
		viewport.rotateAbsolutZ(puffer/180.0*Math.PI);
	}

	void ZRotationSlider_stateChanged(javax.swing.event.ChangeEvent event)
	{
                if(!this.angleOfTransSet )
                {
                    this.setRotationValueViewOnline();
                    return;
                }
		int puffer=ZRotationSlider.getValue();
		zRotation=puffer;
		ZRotationTF.setText(String.valueOf(puffer));
		viewport.rotateAbsolutZ(puffer/180.0*Math.PI);
	}

	void ZoomTF_actionPerformed(java.awt.event.ActionEvent event)
	{
	    double puffer;
	    try{
	        puffer=Math.abs(Double.parseDouble(ZoomTF.getText()));
	    }catch(Exception e){
	        puffer=100.0;
	    }
	    ZoomTF.setText(String.valueOf(Math.round(puffer)));
	    zoom=puffer/100.0;
            viewport.zoomAbsolut(zoom);
	}

	public void setZoomState(double d)
	{
	    ZoomTF.setText(String.valueOf(Math.round(d*100)));
	}

	void XTranslationTF_actionPerformed(java.awt.event.ActionEvent event)
	{
		int puffer;
		try{
		    puffer=Integer.parseInt(XTranslationTF.getText());
		}catch(Exception e){
		    puffer=0;
		}
		if(puffer>100) puffer=100;
		if(puffer<-100) puffer=-100;
		XTranslationTF.setText(String.valueOf(puffer));
		xTranslation=puffer;
		XTranslationSlider.setValue(puffer);
                viewport.translateAbsolutX(puffer);
	}

	void XTranslationSlider_stateChanged(javax.swing.event.ChangeEvent event)
	{
		int puffer=XTranslationSlider.getValue();
		XTranslationTF.setText(String.valueOf(puffer));
		xTranslation=puffer;
                viewport.translateAbsolutX(puffer);
	}

	void YTranslationTF_actionPerformed(java.awt.event.ActionEvent event)
	{
		int puffer;
		try{
		    puffer=Integer.parseInt(YTranslationTF.getText());
		}catch(Exception e){
		    puffer=0;
		}
		if(puffer<-100)puffer=-100;
		if(puffer>100)puffer=100;
		YTranslationTF.setText(String.valueOf(puffer));
		yTranslation=puffer;
		YTranslationSlider.setValue(puffer);
                viewport.translateAbsolutY(puffer);
	}

	void YTranslationSlider_stateChanged(javax.swing.event.ChangeEvent event)
	{
		int puffer=YTranslationSlider.getValue();
		yTranslation=puffer;
		YTranslationTF.setText(String.valueOf(puffer));
                viewport.translateAbsolutY(puffer);
	}

	void ZTranslationTF_actionPerformed(java.awt.event.ActionEvent event)
	{
		int puffer;
		try{
		    puffer=Integer.parseInt(ZTranslationTF.getText());
		}catch(Exception e){
		    puffer=0;
		}
		if(puffer>100) puffer=100;
		if(puffer<-100) puffer=-100;
		ZTranslationTF.setText(String.valueOf(puffer));
		zTranslation=puffer;
		ZTranslationSlider.setValue(puffer);
                viewport.translateAbsolutZ(puffer);
	}

	void ZTranslationSlider_stateChanged(javax.swing.event.ChangeEvent event)
	{
		int puffer=ZTranslationSlider.getValue();
		ZTranslationTF.setText(String.valueOf(puffer));
		zTranslation=puffer;
                viewport.translateAbsolutZ(puffer);
	}

	void FitnessTF_actionPerformed(java.awt.event.ActionEvent event)
	{
		double puffer;
		try{
		    puffer=Double.parseDouble(FitnessTF.getText());
		}catch(Exception e){
		    puffer=0.0;
		}
		if(puffer<0.0) puffer=0.0;
		if(puffer>100.0) puffer=100.0;
		puffer/=100;
		FitnessTF.setText(String.valueOf(puffer*100));
		fitness=puffer;
	}

	void NextB_actionPerformed(java.awt.event.ActionEvent event)
	{
	        double puffer;
		try{
		    puffer=Double.parseDouble(FitnessTF.getText());
		}catch(Exception e){
		    puffer=0.0;
		}
		if(puffer<0.0) puffer=0.0;
		if(puffer>100.0) puffer=100.0;
		puffer/=100;
		FitnessTF.setText(String.valueOf(puffer*100));
		fitness=puffer;
                theSim.setFitness(fitness);
		boolean b=theSim.nextNest();
		int nestNumber=theSim.getIndexOfCurrentNest();
                if(!b&&nestNumber==0)
		{
		      System.out.print("Erniedrige Runden ohne Benutzer auf:");
		      this.roundsToRunWihthoutUser--;
                      System.out.println(this.roundsToRunWihthoutUser);
		}
                setupNewView();
	}
	public void tick()
	{
	    if(building)
	    {
		this.viewport.addCell(theSim.laufeRunden(1));
		this.aktuelleRundenzahl++;
		reviewD.setActualRound(aktuelleRundenzahl);
		this.interactivTF.setText(String.valueOf(this.aktuelleRundenzahl));
	    }
	}
	private void MarkViewB_actionPerformed(java.awt.event.ActionEvent event)
	{
		markViewD.setVisible(true);
	}
	public void setTranslationState(int x,int y,int z)
	{
	    XTranslationSlider.setValue(x);
	    XTranslationTF.setText(String.valueOf(x));
	    YTranslationSlider.setValue(y);
	    YTranslationTF.setText(String.valueOf(y));
	    ZTranslationSlider.setValue(z);
	    ZTranslationTF.setText(String.valueOf(z));
	}

	public void setRotationValueViewOffline()
	{
            this.angleOfTransSet=false;
	    XRotationSlider.setValue(0);
	    XRotationTF.setText("---");
	    YRotationSlider.setValue(0);
	    YRotationTF.setText("---");
	    ZRotationSlider.setValue(0);
	    ZRotationTF.setText("---");
	}
        public void setRotationValueViewOnline()
        {
            this.angleOfTransSet=true;
            ActionEvent e=new ActionEvent(XRotationTF,0,"");
            this.XRotationTF_actionPerformed(e);
            this.YRotationTF_actionPerformed(e);
            this.ZRotationTF_actionPerformed(e);
        }
	public void setStandartRundenZahl(int n)
	{
	    this.standartRundenzahl=n;
	}
	public void setAutomaticFitness(boolean b)
	{
	    this.automaticFitness=b;
	}
	public void setRoundsWithoutUser(int r)
	{
	    this.roundsToRunWihthoutUser=r;
	}

	public void setInteractionMode(boolean b)
	{
	    if(b)
	    {
		this.interactivTF.setEnabled(true);
		this.StartSubTreadB.setEnabled(true);
		this.StopSubTreadB.setEnabled(true);
		this.InteraktionB.setEnabled(true);
		this.standartRundenzahl=0;
		theSim.resetNest();
		this.setupNewView();
	    }
	    else
	    {
		this.interactivTF.setEnabled(false);
		this.StartSubTreadB.setEnabled(false);
		this.StopSubTreadB.setEnabled(false);
		this.InteraktionB.setEnabled(false);
		if(einstellungen!=null)
		    this.standartRundenzahl=einstellungen.getStandartRundenzahl();
		theSim.resetNest();
		this.setupNewView();
	    }
	}

    public class Timer extends Thread {
         public Timer()
         {
	    start();
	 }
	 public void run()
	 {
	    while(true)
	    {
		try{
		    sleep(100);
		}catch(InterruptedException ex){}
		tick();
	    }
        }
    }
}
